unit FidoBase;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FidoMsg;

type
  TFidoMsgBase = class(TComponent)
  private
{ Private declarations }

{   -  }
   BasePath:TFileName;            // 
   LastRead:Word;                 // LastRead Pointer
   { }


  protected
{ Protected declarations }
  function NumToMsgName(mn:integer):string;    //      
                                  //   
  Procedure SetBasePath(BP:TFileName);
  function GetMaxNum:Integer;   //  .    
  function GetMinNum:Integer;   //  .  
  function GetLastRead:Word;    //  LastRead (   !
                                //        lastread
  procedure SetLastRead(lr:word); //   - 


    {    -   protected}

// Procedure SetBasePath(BP:TFileName);
  public
   MaxMsgNum,                     //      
   MinMsgNum,                     //  --------------- // ------------
   CurMsgNum:integer;             //   
   Msg:TFidoMsg;                  //
   NoMore:Boolean;                //  :  ReadNext/ReadPriv = true
                                     //    
                                  //     -  !!!!!

 constructor Create(AOwner:TComponent);virtual;
 destructor Destroy; override;

  function GetNextMsgNum:Integer; // -   . 
  function GetPrevMsgNum:Integer; // -   . 
  function ReadMsg(mn:integer):boolean;  //    mn
  function ReadNextMsg:boolean;  //   
  function ReadPrevMsg:boolean;  //   
  function MsgExist(mn:integer):Boolean;  // True  .   mn
  procedure SetupNewMsg;                  //  Msg    
  function WriteMsg(mn:integer):Boolean;  //    nm
  function WriteNewMsg:boolean;           //    MaxMsgNum+1
  function ReadLastRead:word;
  procedure WriteLastRead(lr:Word);


    { Public declarations }
  published
    { Published declarations }
  property MsgBasePath:TFileName read BasePath write SetBasePath;

  end;



implementation

uses FileCtrl,Wizard;


constructor TFidoMsgBase.Create(AOwner:TComponent);
begin
BasePath:='';
MaxMsgNum:=-1;
MinMsgNum:=-1;
CurMsgNum:=-1;
LastRead:=0;
NoMore:=False;
inherited Create(AOwner);
end;

destructor TFidoMsgBase.Destroy;
begin
Msg.Free;
inherited Destroy;
end;



Procedure TFidoMsgBase.SetBasePath(BP:TFileName);
begin
bp:=AddSlash(BP);
if Not DirectoryExists(bp) then
                                           begin
                                           MaxMsgNum:=-1;
                                           MinMsgNum:=-1;
                                           CurMsgNum:=-1;
                                           exit;
                                           end;
BasePath:=bp;
MaxMsgNum:=GetMaxNum;
MinMsgNum:=MaxMsgNum;
MinMsgNum:=GetMinNum;
LastRead:=ReadLastRead;

if LastRead>MaxMsgNum then LastRead:=MaxMsgNum;
if LastRead<MinMsgNum then LastRead:=MinMsgNum;
CurMsgNum:=LastRead;
if not MsgExist(CurMsgNum) then CurMsgNum:=GetNextMsgNum;
ReadMsg(CurMsgNum);
end;   //TFidoMsgBase.SetBasePath

function TFidoMsgBase.GetMaxNum:Integer;
var SR:TSearchRec;
    t,res:integer;
    s:string;
begin
result:=-1;
res:=FindFirst(BasePath+'*.msg',faAnyFile,sr);
while res=0 do
begin
s:=ExtractFileName(sr.name);
t:=pos('.',sr.name);
if t<>0 then
        begin
         s:=copy(s,1,t-1);
         t:=StrToInt(s);
         if result<t then result:=t;
        end;
res:=FindNext(sr);
end;
FindClose(sr);
end;  //TFidoMsgBase.GetMaxNum

function TFidoMsgBase.GetMinNum:Integer;
var SR:TSearchRec;
    t,res:integer;
    s:string;
begin
result:=MaxMsgNum;
res:=FindFirst(BasePath+'*.msg',faAnyFile,sr);
while res=0 do
begin
s:=ExtractFileName(sr.name);
t:=pos('.',sr.name);
if t<>0 then
        begin
         s:=copy(s,1,t-1);
         t:=StrToInt(s);
         if result>t then result:=t;
        end;
res:=FindNext(sr);
end;
FindClose(sr);
end;  //TFidoMsgBase.GetMinNum

function TFidoMsgBase.ReadLastRead:Word;
var f:file of word;
begin
if fileexists(BasePath+'lastread') then
   begin
    assignfile(f,BasePath+'lastread');
    reset(f);
    read(f,result);
    close(f);
    exit;
   end;
result:=0;
assignfile(f,BasePath+'lastread');
rewrite(f);
write(f,result);
close(f);
end;  //TFidoMsgBase.ReadLastRead

procedure TFidoMsgBase.WriteLastRead(lr:Word);
var f:file of word;
begin
assignfile(f,BasePath+'lastread');
rewrite(f);
write(f,lr);
close(f);
end; //TFidoMsgBase.WriteLastRead

function TFidoMsgBase.GetLastRead:Word;
begin
result:=LastRead;
end;  //TFidoMsgBase.GetLastRead

procedure TFidoMsgBase.SetLastRead(lr:word);
begin
LastRead:=lr;
end;  //TFidoMsgBase.SetLastRead

function TFidoMsgBase.GetNextMsgNum:Integer;
begin
result:=CurMsgNum;
repeat
inc(result);
if result>MaxMsgNum then
                       begin
                        result:=CurMsgNum;
                        NoMore:=True;
                        exit;
                       end;
until MsgExist(result)=true;
NoMore:=False;
end;  //GetNextMsgNum

function TFidomsgBase.GetPrevMsgNum:Integer; // -   . 
begin
result:=CurMsgNum;
repeat
dec(result);
if result<MaxMsgNum then
                       begin
                        result:=CurMsgNum;
                        NoMore:=True;
                        exit;
                       end;
until MsgExist(result);
NoMore:=False;
end;  //TFidomsgBase.GetPrevMsgNum

function TFidomsgBase.MsgExist(mn:integer):Boolean;  // True  .   mn
begin
result:=FileExists(NumToMsgName(mn));
end; // TFidomsgBase.MsgExist

function TFidomsgBase.ReadMsg(mn:integer):boolean;  //    mn
begin
result:=False;
if not MsgExist(mn) then exit;
Msg.Free;
Msg:=TFidoMsg.Create;
if Msg.LoadFromFile(NumToMsgName(mn))=0 then result:=True;

end;  //TFidomsgBase.ReadMsg

function TFidomsgBase.NumToMsgName(mn:integer):string;
begin
result:=BasePath+IntToStr(mn)+'.msg';
end;   //TFidomsgBase.NumToMsgName

function TFidoMsgBase.ReadNextMsg:boolean;
var MNum:LongInt;
begin
MNum:=GetNextMsgNum;
result:=ReadMsg(MNum);
if result then CurMsgNum:=MNum;

end;  // TFidomsgBase.ReadNextMsg

function TFidoMsgBase.ReadPrevMsg:boolean;  //   
var MNum:LongInt;
begin
MNum:=GetNextMsgNum;
result:=ReadMsg(GetPrevMsgNum);
if result then CurMsgNum:=MNum;
end;  // TFidoMsgBase.ReadPrivMsg

procedure TFidoMsgBase.SetupNewMsg;                  //  Msg    
begin
Msg.Free;
Msg:=TFidoMsg.Create;
end; //TFidoMsgBase.SetupNewMsg;

function TFidoMsgBase.WriteMsg(mn:integer):Boolean;  //    nm
begin
if mn<1 then
         begin
          result:=False;
          exit;
         end;
result:=(Msg.SaveToFile(NumToMsgName(mn))=0);
if result then
   begin
    if mn>MaxMsgNum then MaxMsgNum:=mn;
    if mn<MinMsgNum then MinMsgNum:=mn;
   end;
end; //TFidoMsgBase.WriteMsg

function TFidoMsgBase.WriteNewMsg:boolean;           //    MaxMsgNum+1
begin
result:=WriteMsg(MaxMsgNum+1);
end;
end.
