unit FidoMsg;

interface

uses Classes,Address,DatTime,SysUtils,Windows,Wizard;

{$I flag.inc}

const mOk=0;   //
      mNoFile=-1;   //  
      mNoMemory=-2; //  
      mFileError=-3;  //  
      mFWriteError=-4;  //    



type TFidoMsg=class(TObject)
     private
       MsgError:Integer;    //  ...
     public
        //   
      FromName:string[36]; // 
      ToName:String[36];     // 
      Subj:String[36];       // 
      FromAddr:TAddr;        //  
      ToAddr:Taddr;          //  
      DateTime:TDateTime;    // /
      TimesRead:Word;        //  
      Cost:Word;             // 
      ReplyTo:Word;          // 
      Attr:word;             // 
      NextReply:Word;        //  

      MsgText,               //   ( , , , 
      PreKlud:TStringList;      //     (MSGID, INTL,PID, }
      PostKlud:TStringList;      //    (Via,PATH, SeenBy }
      Origin:string;         // 
      Tagline:string;        // 
      Tearline:string;       // 

      constructor Create;virtual;
      destructor Destroy; override;

      function LoadFromFile(FileName:TFileName):integer;
      function SaveToFile(FileName:TFileName):integer;


//         
      function IsPvt:Boolean;                {     } {+   }
      function IsCrash:Boolean;              {     } {+  s}
      function IsRecd:Boolean;               {   }
      function IsSent:Boolean;               {   }
      function IsFileAttach:Boolean;         {    } {+   }
      function IsTransit:Boolean;            { }
      function IsOrphan:Boolean;             {     }
      function IsKillSent:Boolean;           {   }
      function IsLocal:Boolean;              {    }
      function IsHold:Boolean;               {  }
      function IsFReq:Boolean;               {   } {   s}
      function IsRetRecReq:boolean;          {   }
      function IsRetRecFlag:boolean;         {   } { + s}
      function IsAuditReq:boolean;           { } { + s}
      function IsFileUpdateReq:boolean;      { } {   s}

      procedure SetPvt;
      procedure SetCrash;
      procedure SetRecd;
      procedure SetSent;
      procedure SetFileAttach;
      procedure SetTransit;
      procedure SetOrphan;
      procedure SetKillSent;
      procedure SetLocal;
      procedure SetHold;
      procedure SetFReq;
      procedure SetRetRecReq;
      procedure SetRetRecFlag;
      procedure SetAuditReq;
      procedure SetFileUpdateReq;



{s -    ,  
  + -    }

    protected
      function ReadHeader(FileName:TFileName):integer;  // 
      function ReadMsgText(FileName:TFileName):integer; // 
      procedure ReadInfoFromKludges; //      
                                             //  
      function WriteHeader(FileName:TFileName):integer; //  
      function WriteMsgText(FileName:TFileName):integer; // 
    end;

implementation

constructor TFidoMsg.Create;
begin
Inherited Create;
FromName:='';
ToName:='';
Subj:='';
FromAddr:=TAddr.Create;
ToAddr:=Taddr.Create;
DateTime:=StrToDateTime('01.01.81 00:00:00');
TimesRead:=0;
Cost:=0;
ReplyTo:=0;
Attr:=0;
NextReply:=0;
MsgText:=TStringList.Create;
PreKlud:=TStringList.Create;
PostKlud:=TStringList.Create;
Origin:='';
Tagline:='';
Tearline:='';
MsgError:=mOk;
end; //TFidoMsg.Create;

destructor  TFidoMsg.Destroy;
begin
ToAddr.Free;
FromAddr.Free;
MsgText.Free;
PreKlud.Free;
PostKlud.Free;
inherited Destroy;
end; //TFidoMsg.Free;


function TFidoMsg.LoadFromFile(FileName:TFileName):integer;
begin
if (FileName='') or (not FileExists(FileName)) then
                                               begin
                                                msgError:=mNoFile;
                                                result:=mNoFile;
                                                exit;
                                               end;
msgError:=ReadHeader(FileName);
result:=MsgError;
if msgError<>mOk then exit;
msgError:=ReadMsgText(FileName);
result:=MsgError;
if msgError<>mOk then exit;
ReadInfoFromKludges;
result:=mOk;
end; //TFidoMsg.LoadFromFile



function TFidoMsg.ReadHeader(FileName:TFileName):integer;
type PHeadBuf=^THeadBuf;
     THeadBuf=array[0..189] of char;
var Buf:PHeadBuf;
    res,t:integer;
    f:file;
    s:string;
function GetWord(Num:word):Word;
begin
Result:=Byte(buf^[Num])+Byte(buf^[num+1])*256;
end;

begin
try
New(Buf);
except
result:=mNoMemory;
exit;
end;
try
assignfile(f,FileName);
reset(f,1);
blockread(f,Buf^,190,res);
closefile(f);
except
result:=mFileError;
exit;
end;

s:='';
for t:=0 to 35 do if buf[t]=#0 then break else s:=s+buf^[t];
FromName:=Dos2Win(s);

s:='';
for t:=36 to 71 do if buf[t]=#0 then break else s:=s+buf^[t];
ToName:=Dos2Win(s);

s:='';
for t:=72 to 143 do if buf[t]=#0 then break else s:=S+buf^[t];
Subj:=Dos2Win(s);

s:='';
for t:=144 to 163 do if buf[t]=#0 then break else s:=S+buf^[t];
DateTime:=MsgStrToDateTime(s);
TimesRead:=GetWord(164);
ToAddr.SetNode(GetWord(166));
FromAddr.SetNode(GetWord(168));
Cost:=GetWord(170);
FromAddr.SetNet(GetWord(172));
ToAddr.SetNet(GetWord(174));
ToAddr.SetZone(GetWord(176));
FromAddr.SetZone(GetWord(178));
ToAddr.SetPoint(GetWord(180));
FromAddr.SetPoint(GetWord(182));
ReplyTo:=GetWord(184);
Attr:=GetWord(186);
NextReply:=GetWord(188);
Dispose(Buf);
Result:=mOk;
end; //ReadHeader(FileName:TFileName);

function TFidoMsg.ReadMsgText(FileName:TFileName):integer; // 
label Again;
type PBuf=^TBuf;
     TBuf=array[0..255] of char;
var buf:PBuf;
    f:file;
    res,t:integer;
    s,s1:string;
    pr,PostKludFlag:boolean;
begin
try
New(Buf);
 except
  Result:=mNoMemory;
  exit;
 end;
try
 assignfile(f,FileName);
 reset(f,1);
 seek(f,190);
  except
   Result:=mFileError;
   exit;
  end;

pr:=False;
s:='';
PostKludFlag:=False;
BlockRead(f,buf^,256,res);

while res<>0 do
begin
t:=0;
Again:
while (buf^[t]<>#$0d) and (t<=res-1) do
begin
if Buf^[t]=#0 then break;
s:=s+Buf^[t];
inc(t);
if length(s)=80 then
                    begin
                    Pr:=True;
                    s:=s+Buf^[t];
                    break;
                    end;
end;
if (pr=True) or (((Buf^[t]=#$0d) or (Buf^[t]=#0)) and (t<=res-1)) then
                       begin
                       s:=Dos2Win(s);
                       if (s<>'') and (s[1]=#1) then
                               begin
                                if not PostKludFlag then  PreKlud.add(s)
                                                          else PostKlud.Add(s);
                               end
                                            else
                                            begin
                                            PostKludFlag:=True;
                                            s1:=AnsiUpperCase(Copy(s,1,11));
                                            if (s1=' * ORIGIN: ') or (s1=' ! ORIGIN: ') then origin:=s else
                                               begin
                                                 s1:=Copy(s,1,3);
                                                 if (s1='___') or (s1='---') then tearline:=s else
                                                   if s1='...' then tagline:=s else

                                                                               MsgText.Add(s);

                                               end;
                                            end;


                       s:='';
                       pr:=False;

                       end;
if (Buf^[t]=#0) and (t<=256-1) then break;
inc(t);
if t<=res-1 then goto Again;
BlockRead(f,Buf^,256,res);
end;
closeFile(f);
Dispose(Buf);
result:=mOk;
end;  //TFidoMsg.ReadMsgText

procedure TFidoMsg.ReadInfoFromKludges; //      
var res,t:Integer;
    s,s1,dom:string;
    p:word;
begin
for t:=0 to PreKlud.count-1 do
begin
s:=PreKlud.Strings[t];
delete(s,1,1);
s:=AnsiUpperCase(s);
if copy(s,1,6)='MSGID:' then
                        begin
                         delete(s,1,6);
                         s:=DelSp(s);
                         res:=pos(' ',s);
                         delete(s,res,255);
                         FromAddr.ParseStr(s);
                         continue;
                        end;
if copy(s,1,4)='TOPT' then
                          begin
                           delete(s,1,4);
                           s:=delsp(s);
                           ToAddr.SetPoint(strToInt(s));
                           continue;
                          end;

if copy(s,1,4)='FMPT' then
                          begin
                           delete(s,1,4);
                           s:=delsp(s);
                           FromAddr.SetPoint(strToInt(s));
                           continue;
                          end;

if copy(s,1,6)='REPLY:' then
                           begin
                           delete(s,1,6);
                           s:=delsp(s);
                           res:=pos(' ',s);
                           if res<>0 then delete(s,res,255);
                           s:=delsp(s);
                           ToAddr.ParseStr(s);
                           continue;
                           end;
if copy(s,1,4)='INTL' then
                       begin
                        delete(s,1,4);
                        s:=delsp(s);
                        res:=pos(' ',s);
                        s1:=copy(s,1,res-1);
                        p:=ToAddr.GetPoint;
                        Dom:=ToAddr.GetDomain;
                        ToAddr.ParseStr(s1);
                        ToAddr.SetPoint(p);
                        ToAddr.SetDomain(dom);

                        delete(s,1,res);
                        s:=DelSp(s);
                        p:=FromAddr.GetPoint;
                        Dom:=FromAddr.GetDomain;
                        FromAddr.ParseStr(s);
                        FromAddr.SetPoint(p);
                        FromAddr.SetDomain(dom);
                        continue;
                       end;
end;
end; //TFidoMsg.ReadInfoFromKludges


function TFidoMsg.IsPvt:Boolean;
begin
Result:=((Attr and flPvt)<>0);
end;  //TFidoMsg.IsPvt

function TFidoMsg.IsCrash:Boolean;
begin
Result:=((Attr and flCrash)<>0);
end;  //TFidoMsg.IsCrash

function TFidoMsg.IsRecd:Boolean;
begin
Result:=((Attr and flRecd)<>0);
end;  //TFidoMsg.IsRecd

function TFidoMsg.IsSent:Boolean;
begin
Result:=((Attr and flSent)<>0);
end;  //TFidoMsg.IsSent

function TFidoMsg.IsFileAttach:Boolean;
begin
Result:=((Attr and flFileAttach)<>0);
end; //TFidoMsg.IsFileAttach

function TFidoMsg.IsTransit:Boolean;
begin
Result:=((Attr and flTransit)<>0);
end;  //TFidoMsg.IsTransit

function TFidoMsg.IsOrphan:Boolean;
begin
Result:=((Attr and flOrphan)<>0);
end;  //TFidoMsg.IsOrphan

function TFidoMsg.IsKillSent:Boolean;           {   }
begin
Result:=((Attr and flKillSent)<>0);
end;   //TFidoMsg.IsKillSent

function TFidoMsg.IsLocal:Boolean;              {    }
begin
Result:=((Attr and flLocal)<>0);
end;   //TFidoMsg.IsLocal

function TFidoMsg.IsHold:Boolean;               {  }
begin
Result:=((Attr and flHold)<>0);
end;  //TFidoMsg.IsHold

function TFidoMsg.IsFReq:Boolean;               {   } {   s}
begin
Result:=((Attr and flFileRequest)<>0);
end;   //TFidoMsg.IsFReq

function TFidoMsg.IsRetRecReq:boolean;          {   }
begin
Result:=((Attr and flReturnReceiptRequest)<>0);
end;   //TFidoMsg.IsRetRecReq

function TFidoMsg.IsRetRecFlag:boolean;         {   } { + s}
begin
Result:=((Attr and flReturnReceiptFlag)<>0);
end;   //TFidoMsg.IsRetRecFlag

function TFidoMsg.IsAuditReq:boolean;           { } { + s}
begin
Result:=((Attr and flAuditRequest)<>0);
end;  //TFidoMsg.IsAuditReq

function TFidoMsg.IsFileUpdateReq:boolean;      { } {   s}
begin
Result:=((Attr and flFileUpdateReq)<>0);
end;   //TFidoMsg.IsFileUpdateReq

procedure TFidoMsg.SetPvt;
begin
attr:=(attr or flPvt);
end;  //TFidoMsg.SetPvt;

procedure TFidoMsg.SetCrash;
begin
attr:=(attr or flCrash);
end;  //TFidoMsg.SetCrash;

procedure TFidoMsg.SetRecd;
begin
attr:=(attr or flRecd);
end;  //TFidoMsg.SetRecd;

procedure TFidoMsg.SetSent;
begin
attr:=(attr or flSent);
end;  //TFidoMsg.SetSent;


procedure TFidoMsg.SetFileAttach;
begin
attr:=(attr or flFileAttach);
end;  //TFidoMsg.SetFileAttach;

procedure TFidoMsg.SetTransit;
begin
attr:=(attr or flTransit);
end;  //TFidoMsg.SetTransit;

procedure TFidoMsg.SetOrphan;
begin
attr:=(attr or flOrphan);
end;  //TFidoMsg.SetOrphan;

procedure TFidoMsg.SetKillSent;
begin
attr:=(attr or flKillSent);
end;  //TFidoMsg.SetKillSent;

procedure TFidoMsg.SetLocal;
begin
attr:=(attr or flLocal);
end;  //TFidoMsg.SetLocal;

procedure TFidoMsg.SetHold;
begin
attr:=(attr or flHold);
end;  //TFidoMsg.SetHold;

procedure TFidoMsg.SetFReq;
begin
attr:=(attr or flFileRequest);
end;  //TFidoMsg.SetFReq;

procedure TFidoMsg.SetRetRecReq;
begin
attr:=(attr or flReturnReceiptRequest);
end;  //TFidoMsg.SetRetRecReq;

procedure TFidoMsg.SetRetRecFlag;
begin
attr:=(attr or flReturnReceiptRequest);
end;  //TFidoMsg.SetRetRecFlag;

procedure TFidoMsg.SetAuditReq;
begin
attr:=(attr or flAuditRequest);
end;  //TFidoMsg.SetAuditReq;

procedure TFidoMsg.SetFileUpdateReq;
begin
attr:=(attr or flFileUpdateReq );
end;  //TFidoMsg.SetFileUpdateReq;


function TFidoMsg.SaveToFile(FileName:TFileName):integer;
var f:file;


begin
try
 assignfile(f,FileName);
 rewrite(f,1);
except
 result:=mFWriteError;
 exit;
end;

closefile(f);


result:=WriteHeader(FileName);
if result<>mOk then
                  begin
                   closefile(f);
                   exit;
                  end;
result:=WriteMsgText(FileName);

end;  //TFidoMsg.SaveToFile

function TFidoMsg.WriteHeader(FileName:TFileName):integer;
type PBuf=^TBuf;
     TBuf=array[1..73] of char;

var buf:PBuf;
    res:integer;
    f:file;

procedure WrStr(s:string;cnt:integer);
var t:integer;
begin
s:=Win2Dos(s);
for t:=1 to length(s) do buf^[t]:=s[t];
for t:=length(s)+1 to cnt do buf^[t]:=#0;
blockwrite(f,buf^,cnt,res);
end;

procedure WrWord(w:word);
begin
blockwrite(f,w,2,res);
end;


begin
try
New(buf);
except
result:=mNoMemory;
exit;
end;

assignfile(f,FileName);
rewrite(f,1);

WrStr(FromName,36);
WrStr(ToName,36);
WrStr(Subj,72);
WrStr(DateTimeToMsgStr(DateTime),20);

WrWord(TimesRead);
WrWord(ToAddr.GetNode);
WrWord(FromAddr.GetNode);
WrWord(Cost);
WrWord(FromAddr.GetNet);
WrWord(ToAddr.getNet);
WrWord(ToAddr.GetZone);
WrWord(FromAddr.GetZone);
WrWord(ToAddr.GetPoint);
WrWord(FromAddr.GetPoint);
WrWord(ReplyTo);
WrWord(Attr);
WrWord(NextReply);
Dispose(buf);
result:=mOk;
CloseFile(f);
end; //TFidoMsg.WriteHeader;

function TFidoMsg.WriteMSgText(FileName:TFileName):Integer;
type PBuf=^TBuf;
     TBuf=array[1..81] of char;
var Buf:PBuf;
    hl:integer;

procedure WrStr(s:string);
var t:integer;
begin
s:=Win2Dos(s);
for t:=1 to length(s) do buf^[t]:=s[t];
buf^[length(s)+1]:=#$0d;
filewrite(hl,buf^,length(s)+1);
end;
procedure WrList(List:TStringList);
var t:integer;
begin
for t:=0 to List.Count-1 do
    WrStr(List.Strings[t]);
end;


begin
try
new(Buf);
except
result:=mNoMemory;
exit;
end;

hl:=FileOpen(FileName,fmOpenReadWrite);
FileSeek(hl,190,0);

WrList(PreKlud);
WrList(MsgText);
if TagLine<>'' then WrStr(TagLine);
if TearLine<>'' then WrStr(TearLine);
if Origin<>'' then WrStr(Origin);
WrList(PostKlud);
FIleClose(hl);
Dispose(Buf);
Result:=mOk;
end; //TFidoMsg.WriteMSgText;

end.
